module("luci.controller.tcpdump",package.seeall)
tcpdump_root_folder="/tmp/tcpdump/"
tcpdump_cap_folder=tcpdump_root_folder.."cap/"
tcpdump_filter_folder=tcpdump_root_folder.."filter/"
pid_file=tcpdump_root_folder.."tcpdump.pid"
log_file=tcpdump_root_folder.."tcpdump.log"
out_file=tcpdump_root_folder.."tcpdump.out"
sleep_file=tcpdump_root_folder.."tcpdump.sleep"
function index()
template("myapp-mymodule/helloworld")
entry({"admin","network","tcpdump"},template("tcpdump"),_"Tcpdump",70).dependent=
false
page=entry({"admin","network","tcpdump","capture_start"},
call("capture_start"),nil)
page.leaf=true
page=entry({"admin","network","tcpdump","capture_stop"},
call("capture_stop"),nil)
page.leaf=true
page=entry({"admin","network","tcpdump","update"},call("update"),nil)
page.leaf=true
page=entry({"admin","network","tcpdump","capture_get"},
call("capture_get"),nil)
page.leaf=true
page=entry({"admin","network","tcpdump","capture_remove"},
call("capture_remove"),nil)
page.leaf=true
end
function param_check(o,n,a,e)
local e=false
local t={}
if o==nil or o==''then
table.insert(t,"Interface name is null or blank.")
end
local i=require"nixio"
for a,t in ipairs(i.getifaddrs())do
if t.family=="packet"then
if o==t.name then
e=true
break
end
end
end
if iface=='any'then e=true end
if not e then
table.insert(t,"Interface does not exist or is not valid.")
end
if tonumber(n)==nil then
e=false
table.insert(t,"Capture length parameter must be a number.")
end
if a==nil then
e=false
table.insert(t,"Capture unit is null or blank.")
else
a=string.upper(a)
if a~="T"and a~="P"then
e=false
table.insert(t,"Capture unit must be Time(T) or packet(P).")
end
end
return e,t
end
function capture_start(s,i,n,a)
local o,e=capture_active()
local t={}
local e={}
if o then
e["ok"]=false
e["msg"]={"Previous capture is still ongoing!"}
else
local h,o=param_check(s,i,n,a)
if not h then
e["ok"]=false
e["msg"]=o
else
os.execute("mkdir -p "..tcpdump_cap_folder)
os.execute("mkdir -p "..tcpdump_filter_folder)
local o="capture_"..os.date("%Y-%m-%d_%H.%M.%S")
local r=tcpdump_cap_folder..o..".pcap"
local h=tcpdump_filter_folder..o..".filter"
string_to_file(h,a)
string_to_file(out_file,o)
tcpdump_start(s,i,n,h,r)
t["filter"]=a
e["ok"]=true
e["msg"]={"Capture in progress.."}
end
end
t["cmd"]=e
t["capture"]=capture()
t["list"]=list()
luci.http.prepare_content("application/json")
luci.http.write_json(t)
end
function string_to_file(t,e)
if e==nil then e=""end
local t=io.open(t,"w")
t:write(e)
t:close()
end
function tcpdump_start(o,t,a,i,n)
local e="tcpdump -i %s -F %s -w %s"
e=string.format(e,o,i,n)
if tonumber(t)~=0 and a=="P"then
e=e.." -c "..t
end
e=string.format("%s &> %s & echo $! > %s",e,log_file,pid_file)
os.execute(e)
if tonumber(t)~=0 and a=="T"then
local e=io.open(pid_file,"r")
if e~=nil then
local a=e:read()
e:close()
local e=
string.format("sleep %s && kill %s &",t,a)
os.execute(e)
end
end
end
function capture_stop()
local t={}
local e={}
local i,o,a=capture()
if o then
luci.sys.process.signal(a,9)
e["ok"]=true
e["msg"]={"Capture has been terminated"}
else
e["ok"]=false
e["msg"]={"There was not active capture!"}
end
capture_cleanup()
t["cmd"]=e
t["capture"]=capture()
t["list"]=list()
luci.http.prepare_content("application/json")
luci.http.write_json(t)
end
function capture_active()
local e=io.open(pid_file,"r")
if e~=nil then
pid=e:read()
e:close()
if tonumber(pid)~=nil and luci.sys.process.signal(pid,0)then
return true,pid
end
end
return false,nil
end
function capture_log()
local t
local e=io.open(log_file,"r")
if e~=nil then
t=e:read("*all")
e:close()
else
t=""
end
return t
end
function capture_name()
local t=nil
local e=io.open(out_file,"r")
if e~=nil then
t=e:read()
e:close()
end
return t
end
function capture()
local o=require"nixio.fs"
local e={}
local t,a=capture_active()
local i
e["active"]=t
e["log"]=capture_log()
if t then
e["msg"]="Capture in progress.."
e["cap_name"]=capture_name()
elseif o.access(pid_file)then
capture_cleanup()
e["msg"]="Process seems to be dead, removing pid file!"
else
e["msg"]="No capture in progress"
end
return e,t,a
end
function capture_cleanup()
os.remove(pid_file)
os.remove(log_file)
os.remove(out_file)
local e=io.open(sleep_file,"r")
if e~=nil then
pid=e:read()
e:close()
if tonumber(pid)~=nil or not luci.sys.process.signal(pid,0)then
luci.sys.process.signal(pid,9)
end
end
os.remove(sleep_file)
end
function list_entries(i)
local e=require"nixio.fs"
local n={}
local a
local h
local s
local o
local t
if i==nil then
t=tcpdump_cap_folder.."*.pcap"
else
t=tcpdump_cap_folder..i..".pcap"
end
for t in e.glob(t)do
a=string.sub(e.basename(t),1,-6)
h=e.stat(t,"size")
s=e.stat(t,"ctime")
if e.access(tcpdump_filter_folder..a..".filter")then
o=true
else
o=false
end
table.insert(n,
{name=a,size=h,mtime=s,filter=o})
end
return n
end
function list(e)
res={}
res["entries"]=list_entries(e)
res["update"]=(e~=nil)
return res
end
function update(a)
local e={}
local t={}
t["ok"]=true
e["cmd"]=t
e["capture"]=capture()
e["list"]=list(a)
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function pump_file(e,a)
local t=io.open(e)
local o=luci.ltn12.source.file(t)
luci.http.header("Content-Disposition","attachment; filename=\""..
nixio.fs.basename(e).."\"")
if a~=nil then
luci.http.prepare_content(a)
else
luci.http.prepare_content("application/octet-stream")
end
luci.ltn12.pump.all(o,luci.http.write)
t:close()
end
function capture_get(e,t)
if e=="all"then
local e=require"luci.controller.admin.system"
local t="tar -c "..tcpdump_cap_folder..
"*.pcap 2>/dev/null"
local e=e.ltn12_popen(t)
luci.http.header('Content-Disposition',
'attachment; filename="captures-%s.tar"'%
{os.date("%Y-%m-%d_%H.%M.%S")})
luci.http.prepare_content("application/x-tar")
luci.ltn12.pump.all(e,luci.http.write)
elseif e=="pcap"then
local e=tcpdump_cap_folder..t..'.pcap'
pump_file(e)
elseif e=="filter"then
local e=tcpdump_filter_folder..t..'.filter'
pump_file(e,"text/plain")
else
end
end
function capture_remove(e)
if e=='all'then
local e=require"nixio.fs"
for e in e.glob(tcpdump_cap_folder.."*.pcap")do
os.remove(e)
end
for e in e.glob(tcpdump_filter_folder.."*.filter")do
os.remove(e)
end
else
os.remove(tcpdump_cap_folder..e..".pcap")
os.remove(tcpdump_filter_folder..e..".filter")
end
update()
end
